package telas;


import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class TelaPrincipal extends JFrame implements ActionListener,MouseListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	/*
	 * Variaveis 
	 */
	
	private int largura,altura,tipoResolucao; //tipoResolucao 0=1024x768 1=800x600 2=600x400
	private ImageIcon[][] imgBtResolucao,imgBtSobre,imgBtInicia;
	private ImageIcon[] imgFundo,imgTitulo;
	private JButton btResolucao,btSobre;
	private JLabel tela,topo,btIniciar;

	public TelaPrincipal(int largura, int altura, int reso) {
		this.largura=largura;
		this.altura=altura;
		this.tipoResolucao= reso;
		setTitle("Nugoli Car Racing 1.3");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 617, 489);
		setSize(largura,altura);
		setLocationRelativeTo(null);
		setResizable(false);
		CarregaImagens();
		add(areaTrabalho());
	}
	
	private void CarregaImagens(){
		imgBtResolucao = new ImageIcon[3][3];
		imgBtSobre = new ImageIcon[3][3];
		imgFundo = new ImageIcon[3];
		imgTitulo = new ImageIcon[3];
		imgBtInicia = new ImageIcon[2][3];
		for(int i=0;i<3;i++){
			imgFundo[i]=new ImageIcon("img\\fundo\\fundo"+(i+1)+".gif");
			imgTitulo[i]=new ImageIcon("img\\fundo\\topo"+(i+1)+".png");
			for(int y=0;y<3;y++){
				switch (i) {
					case 0:
						imgBtResolucao[i][y] = new ImageIcon("img\\bt_resolucao\\bt_reso"+(y+1)+"_full.png");
						imgBtSobre[i][y] = new ImageIcon("img\\bt_sobre\\bt_sobre"+(y+1)+"_full.png");
						imgBtInicia[i][y] = new ImageIcon("img\\bt_iniciar\\iniciarEstatico"+(y+1)+".gif");
						break;
					case 1:
						imgBtResolucao[i][y] = new ImageIcon("img\\bt_resolucao\\bt_reso"+(y+1)+"_medio.png");
						imgBtSobre[i][y] = new ImageIcon("img\\bt_sobre\\bt_sobre"+(y+1)+"_medio.png");
						imgBtInicia[i][y] = new ImageIcon("img\\bt_iniciar\\inicia"+(y+1)+".gif");
						break;
					case 2:                                             
						imgBtResolucao[i][y] = new ImageIcon("img\\bt_resolucao\\bt_reso"+(y+1)+"_low.png");
						imgBtSobre[i][y] = new ImageIcon("img\\bt_sobre\\bt_sobre"+(y+1)+"_low.png");
					break;
				}
			}
		}
	}
		
		
	private JPanel areaTrabalho(){
		
		JPanel areaTrabalho=new JPanel(); 
		areaTrabalho.setLayout(null);
		areaTrabalho.setPreferredSize(new Dimension(largura, altura));
		int yEntreBt=0,yEntreBt1=0;
		tela = new JLabel();
		tela.setIcon(imgFundo[tipoResolucao]);
		tela.setBounds(0, 0, largura, altura);
		
		topo = new JLabel();
		topo.setIcon(imgTitulo[tipoResolucao]);
		topo.setBounds(0, 0, imgTitulo[tipoResolucao].getIconWidth(), imgTitulo[tipoResolucao].getIconHeight());
		
		
		btIniciar = new JLabel();
		btIniciar.setIcon(imgBtInicia[0][tipoResolucao]);
		btIniciar.addMouseListener(this);
		
		
		btResolucao = new JButton();
		btResolucao.setIcon(imgBtResolucao[tipoResolucao][0]);
		btResolucao.addMouseListener(this);
		btResolucao.setBorder(null);
		btResolucao.setBorderPainted(false);
		btResolucao.setFocusable(false);
		btResolucao.setContentAreaFilled(false);
		
		
		
		btSobre = new JButton();
		btSobre.setIcon(imgBtSobre[tipoResolucao][0]);
		btSobre.addMouseListener(this);
		btSobre.setBorder(null);
		btSobre.setBorderPainted(false);
		btSobre.setFocusable(false);
		btSobre.setContentAreaFilled(false);
		
		yEntreBt=altura-(imgBtSobre[tipoResolucao][0].getIconHeight()+100);
		yEntreBt1=yEntreBt-(10+imgBtResolucao[tipoResolucao][0].getIconHeight());
		
		btIniciar.setBounds((largura/2)-(imgBtInicia[0][tipoResolucao].getIconWidth()/2),yEntreBt1-(40+imgBtInicia[0][tipoResolucao].getIconHeight()), imgBtInicia[0][tipoResolucao].getIconWidth(), imgBtInicia[0][tipoResolucao].getIconHeight());
		btResolucao.setBounds((largura/2)-(214-(64*tipoResolucao))/2, yEntreBt1, 214-(64*tipoResolucao),40-(12*tipoResolucao));
		btSobre.setBounds((largura/2)-(214-(64*tipoResolucao))/2,yEntreBt, 214-(64*tipoResolucao),40-(12*tipoResolucao));
		
		
		areaTrabalho.add(btIniciar);
		areaTrabalho.add(btSobre);
		areaTrabalho.add(btResolucao);
		areaTrabalho.add(topo);
		areaTrabalho.add(tela);
	
		return areaTrabalho;
	}
	
	public int getLargura() {
		return largura;
	}

	public int getAltura() {
		return altura;
	}

	public int getTipoResolucao() {
		return tipoResolucao;
	}

	public void setTipoResolucao(int tipoResolucao) {
		this.tipoResolucao = tipoResolucao;
	}

	public void setLargura(int largura) {
		this.largura = largura;
	}

	public void setAltura(int altura) {
		this.altura = altura;
	}
	
		
	//	Eventos de Ao do Botes
	@Override
	public void mouseClicked(MouseEvent arg0) {
		if(arg0.getSource()==btResolucao){
			Resolucao escolhaReso = new Resolucao();
			escolhaReso.enviaFrame(this);
			//setVisible(false);
			dispose();
			escolhaReso.setVisible(true);
		}
		if(arg0.getSource()==btSobre){
			Sobre  sobre = new Sobre();
			sobre.setVisible(true);
		}
		
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		if(arg0.getSource()==btResolucao)
			btResolucao.setIcon(imgBtResolucao[tipoResolucao][1]);
		if(arg0.getSource()==btSobre)
			btSobre.setIcon(imgBtSobre[tipoResolucao][1]);
		if(arg0.getSource()==btIniciar)
			btIniciar.setIcon(imgBtInicia[1][tipoResolucao]);
		
	}

	@Override
	public void mouseExited(MouseEvent arg0) {
		if(arg0.getSource()==btResolucao)
			btResolucao.setIcon(imgBtResolucao[tipoResolucao][0]);
		if(arg0.getSource()==btSobre)
			btSobre.setIcon(imgBtSobre[tipoResolucao][0]);
		if(arg0.getSource()==btIniciar)
			btIniciar.setIcon(imgBtInicia[0][tipoResolucao]);
		
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		if(arg0.getSource()==btResolucao)
			btResolucao.setIcon(imgBtResolucao[tipoResolucao][2]);
		if(arg0.getSource()==btSobre)
			btSobre.setIcon(imgBtSobre[tipoResolucao][2]);
		
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		
		
	}

}
