/*
 * Antonio Ronaldo Nugoli 
 * Rgm: 015724
 * Universidade Estadual de Mato  Grosso do Sul - UEMS
 * Sistemas de Informao
 * Projeto Final de Curso II
 * 
 * Implementao de um Game Interativo Utilizando a Biblioteca OpenCV
 * Jogo: Nugoli Racing Web Cam
 * 
 * Descrio da Classe:
 * Monta trechos da pista com carros, placas e alvores que seram mostrados pela classe fase
 */

package jogo;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;

public class RenderPista {
	private Pista[] pista;
	private int startPos = 1, camH, comprimento, x[] = { 0, 0, 0, 0 }, y[] = { 0, 0, 0, 0 }, largura, altura, pos = 0,
			segL;
	private Jogador jogador;
	private Pista[] aux;

	// Itens do cenrio
	private Image ceu, sol, colinas;
	private int cenariox, cenariox1, colinasx, colinasx1, xsol, ysol, contaTempo = 0;
	private TestaColisao colidio;
	private int camera = 1000;
	private BufferedImage fimJogo;
	private boolean fimDeJogo, iniciou = false;

	public RenderPista(Pista[] pista, int comprimento, int largura, int altura, int segL, Jogador jogador) {
		this.pista = pista;
		this.comprimento = comprimento;
		this.altura = altura;
		this.largura = largura;
		this.segL = segL;
		this.jogador = jogador;
		cenariox = 0;
		cenariox1 = largura;
		colinasx = 0;
		colinasx1 = largura * (-1);
		xsol = largura - 150;
		ysol = altura * 15 / 100;
		aux = pista;
		ImageIcon referencia = new ImageIcon("img\\ceu2.png");
		ceu = referencia.getImage();
		referencia = new ImageIcon("img\\sol2.png");
		sol = referencia.getImage();
		referencia = new ImageIcon("img\\colinas.png");
		colinas = referencia.getImage();
		referencia = new ImageIcon("img\\morreu.png");

		try {
			fimJogo = ImageIO.read(new File("img\\morreu.png"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		colidio = new TestaColisao();
		fimDeJogo = false;
	}

	public boolean isFimDeJogo() {
		return fimDeJogo;
	}

	public void carregaPistaAux() {
		for (int i = 0; i < comprimento; i++) {
			BufferedImage imagem;
			float cx;
			imagem = pista[i].getImg_cenario();
			cx = pista[i].getImg_cenariox();
			aux[i].setImg_cenario(imagem);
			aux[i].setImg_cenariox(cx);

		}
	}

	public void atualiza() {

		if (iniciou)
			pos += segL;

		cenariox--;
		cenariox1--;
		if (cenariox < (largura * (-1)))
			cenariox = largura - 1;

		if (cenariox1 < (largura * (-1)))
			cenariox1 = largura - 1;

		if (pista[startPos].getCurva() < 0) {
			// if(pos!=controle.getPos()){

			xsol -= 2;
			colinasx -= 2;
			colinasx1 -= 2;
			if (colinasx < largura * -1)
				colinasx = largura - 2;
			if (colinasx1 < largura * -1)
				colinasx1 = largura - 2;
			if (!jogador.getEmuso())
				jogador.setAtual(2);

		}

		if (pista[startPos].getCurva() == 0) {
			if (!jogador.getEmuso())
				jogador.setAtual(0);
		}

		if (pista[startPos].getCurva() > 0) {

			xsol += 2;
			colinasx1 += 2;
			colinasx += 2;
			if (colinasx > largura)
				colinasx = (largura * -1) + 2;
			if (colinasx1 > largura)
				colinasx1 = (largura * -1) + 2;
			if (!jogador.getEmuso())
				jogador.setAtual(1);
		}

		// }
		/*
		 * else{ if(contador<3){ pos-=segL; contador++; }
		 */

		if (contaTempo % 20 == 0) {
			xsol--;
			ysol--;
		}
		contaTempo++;
	}

	public Graphics desenha(Graphics g) {
		Graphics g2 = (Graphics2D) g;

		Color grama, zebra, estrada, faixa;

		// Desenha o fundo do cenrio
		g2.drawImage(ceu, cenariox, 0, largura, altura / 2, null);
		g2.drawImage(ceu, cenariox1, 0, largura, altura / 2, null);
		g2.drawImage(sol, xsol, ysol, (largura * 15) / 100, (largura * 15) / 100, null);
		g2.drawImage(colinas, colinasx, altura / 6, largura, altura / 2, null);
		g2.drawImage(colinas, colinasx1, altura / 6, largura, altura / 2, null);

		g2.setColor(Color.blue);
		g2.setFont(new Font("Stencil", Font.ITALIC, ((largura * 4) / 100)));

		// Imprime na tela a distncia percorrida
		g2.drawString(startPos + " Mt/ " + comprimento / 1000 + " km", 20, (largura * 4) / 100 + 10);

		while (pos >= comprimento * segL)
			pos -= comprimento * segL;
		while (pos < 0)
			pos += comprimento * segL;

		startPos = pos / segL;

		// Define o ponto de viso da cmera para a pista
		camH = camera + (int) pista[startPos].gety();

		float x1 = 0, dx = 0;
		int maxy = altura;
		g2.clearRect(0, altura / 2, largura, altura / 2);
		for (int n = startPos; n < startPos + 300; n++) {

			// Controla a viso da camera nos eixos x,y,z
			pista[n % comprimento].projetar(x1, camH, pos - (n >= comprimento ? comprimento * segL : 0));
			x1 += dx;
			dx += pista[n % comprimento].getCurva();

			pista[n % comprimento].setClip(maxy);

			if (pista[n % comprimento].getY() >= maxy)
				continue;

			maxy = (int) pista[n % comprimento].getY();

			// Define quantos segmentos vai ter uma faixa da pista e alterna
			// suas cores para mais fraco ou mais forte
			if ((n / 3) % 2 == 0) {
				grama = new Color(222, 200, 95);
				zebra = new Color(20, 20, 20);
				estrada = new Color(107, 107, 107);
				faixa = new Color(255, 255, 0);
			} else {
				grama = new Color(216, 189, 63);
				zebra = new Color(255, 255, 255);
				estrada = new Color(105, 105, 105);
				faixa = new Color(105, 105, 105);
			}

			// desenha grama
			if (n != 0) {
				carregaPontos(0, (int) pista[(n - 1) % comprimento].getY(), largura, 0,
						(int) pista[n % comprimento].getY(), 1024);
				g2.setColor(grama);
				g2.fillPolygon(x, y, 4);

				// desenha zebra
				carregaPontos((int) pista[(n - 1) % comprimento].getX(), (int) pista[(n - 1) % comprimento].getY(),
						(int) (pista[(n - 1) % comprimento].getW() * 1.1), (int) pista[n % comprimento].getX(),
						(int) pista[n % comprimento].getY(), (int) (pista[n % comprimento].getW() * 1.1));
				g2.setColor(zebra);
				g2.fillPolygon(x, y, 4);

				// desenha pista
				carregaPontos((int) pista[(n - 1) % comprimento].getX(), (int) pista[(n - 1) % comprimento].getY(),
						(int) (pista[(n - 1) % comprimento].getW()), (int) pista[n % comprimento].getX(),
						(int) pista[n % comprimento].getY(), (int) (pista[n % comprimento].getW()));
				g2.setColor(estrada);
				g2.fillPolygon(x, y, 4);

				// desenha Faixa
				carregaPontos((int) pista[(n - 1) % comprimento].getX(), (int) pista[(n - 1) % comprimento].getY(),
						(int) (pista[(n - 1) % comprimento].getW() * 0.04), (int) pista[n % comprimento].getX(),
						(int) pista[n % comprimento].getY(), (int) (pista[n % comprimento].getW() * 0.04));
				g2.setColor(faixa);
				g2.fillPolygon(x, y, 4);
			}
		}

		int contador = 0;

		// Desenha o trecho de pista para um ciclo do loop da fase
		for (int n = startPos + 300; n > startPos; n--) {

			if (pista[n % comprimento].getImg_cenario() != null) {
				int pontos[] = { 0, 0, 0, 0, 0, 0 };
				pontos = pista[n % comprimento].desenhaObjetos();

				if ((pontos[4] > 0) && (pontos[5] > 0) && contador < 295) {
					if (pista[n % comprimento].isCarro()) {
						g2.drawRect(pontos[0] + (pontos[2] * 20 / 100) / 2, pontos[1] + (pontos[3] / 2),
								pontos[2] - (pontos[2] * 20 / 100), pontos[3] / 2);
					}
					g2.drawImage(pista[n % comprimento].getImg_cenario(), pontos[0], pontos[1], pontos[2], pontos[3],
							null);
				}

				if (pista[n % comprimento].isCarro()) {
					if (colidio.colisao(jogador.getX() + ((jogador.getLarg() * 20 / 100) / 2), jogador.getY() + 20,
							jogador.getLarg() - (jogador.getLarg() * 20 / 100), jogador.getAlt(),
							pontos[0] + (pontos[2] * 20 / 100) / 2, pontos[1] + (pontos[3] / 2),
							pontos[2] - (pontos[2] * 20 / 100), pontos[3] / 2)) {

						g2.drawImage(fimJogo, 0, 0, largura, altura, null);

						fimDeJogo = true;
						break;
					}
				}
			}
			contador++;
		}

		/*
		 * igual as nuvens uso duas imagems para as montanhas ai dependendo se
		 * for reta ou curva a imagem se movimenta para direita ou esquerda
		 * sempre alternando sua posio em x quando necessrio para no sumir
		 * da tela
		 */

		return g2;
	}

	public int getStartPos() {
		return startPos;
	}

	// Pega as informaes dos segmentos de pista para formar um poligono para
	// criar a representao visual da pista na tela
	public void carregaPontos(int x1, int y1, int w1, int x2, int y2, int w2) {
		x[2] = x1 + w1;
		x[3] = x1 - w1;
		x[0] = x2 - w2;
		x[1] = x2 + w2;
		y[0] = y2;
		y[1] = y2;
		y[2] = y1;
		y[3] = y1;
	}

	public void setIniciou(boolean iniciou) {
		this.iniciou = iniciou;
	}

}
