/*
 * Antonio Ronaldo Nugoli 
 * Rgm: 015724
 * Universidade Estadual de Mato  Grosso do Sul - UEMS
 * Sistemas de Informao
 * Projeto Final de Curso II
 * 
 * Implementao de um Game Interativo Utilizando a Biblioteca OpenCV
 * Jogo: Nugoli Racing Web Cam
 * 
 * Descrio da Classe:
 * Responsvel em gerenciar o arquivo com o placar dos jogadores
 * 
 */
package placar;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class RegistraPlacar {
	private final static String arqPlacar = "files//placar.txt";  //O arquivo fica guardado na pasta files no diretrio do jogo
	private BufferedWriter escreverb;
	private int maior;
	private File arquivo;

	// O construtor carrega o arquivo e guarda o maior placar
	public RegistraPlacar() {
		ArrayList<String> resultado = new ArrayList<String>();
		arquivo = criaArquivo();
		resultado = carregaArquivo(arquivo);
		maior = retornaMaior(resultado);
	}

	public int getMaior() {
		return maior;
	}

	// Grava o resultado da partida no arquivo
	public void escrverArquivo(String texto) {

		try {
			FileWriter escrever = new FileWriter(arquivo, true);
			escreverb = new BufferedWriter(escrever);
			escreverb.write(texto);
			escreverb.newLine();
			escreverb.flush();
			escrever.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	// Percorre todas o Array com as linhas do arquivo em busca do maior placar
	public int retornaMaior(ArrayList<String> arquivo) {

		int contador = 0, maior;
		if (arquivo.get(0) != null)
			maior = Integer.parseInt(arquivo.get(0));
		else
			maior = 0;

		while (arquivo.get(contador) != null) {
			if (maior < Integer.parseInt(arquivo.get(contador)))
				maior = Integer.parseInt(arquivo.get(contador));
			contador++;
		}

		return maior;

	}

	// Grava o contedo do arquivo em um Array
	public ArrayList<String> carregaArquivo(File arquivo) {
		ArrayList<String> placar = new ArrayList<String>();
		FileReader ler = null;
		String linha = null;
		try {
			ler = new FileReader(arquivo);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		BufferedReader lerb = new BufferedReader(ler);

		try {
			linha = lerb.readLine();
			placar.add(linha);
			while (linha != null) {
				linha = lerb.readLine();
				placar.add(linha);

			}

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();

		}
		return placar;

	}

	// Caso no haja um arquivo de placar cria um novo
	private File criaArquivo() {
		arquivo = new File(arqPlacar);

		if (!arquivo.exists()) {
			try {
				arquivo.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return arquivo;
	}

}
